<?php

####################################################################################
#### XML관련 클라스 모음 (간단한 예)
####################################################################################

####################################################################################
#### XML관련 parsing
####################################################################################
class xmlparse {
	var $parser;
	var $tagname = "";
	var $filename = array();
	var $cnt = 0;
	function xml(){
		$this->parser = xml_parser_create();

		xml_set_object($this->parser, $this);
		xml_set_element_handler($this->parser, "tag_open", "tag_close");
		xml_set_character_data_handler($this->parser, "cdata");
	}

	function parse($data){
		xml_parse($this->parser, $data);
	}

	function tag_open($parser, $tag, $attributes){//테그를 열때마다실행
		if($tag == "CHANNEL"){
			$this->cnt++;
		}
		$this->tagname = $tag;
	}

	function cdata($parser, $cdata){//태그를 연후 내용 실행
		if(trim($cdata)){
			$cnt = $this->cnt;
			$this->filename[$this->tagname][$cnt] = $cdata;
		}
	}

	function tag_close($parser, $tag){ 

	}

} // end of class xml


####################################################################################
#### XML creating
####################################################################################
class xmlcreate{
	var $items					= array();
	var $printheadenable		= false; 
	var $subchannel			= 1;
	function outputXml(){
		//echo "adfasdf";
		header("Content-type: text/xml");
		printf("<?xml version=\"1.0\" encoding=\"%s\" ?>\n","utf-8");
		//print("<rss version=\"2.0\">\n");
print("<rss version=\"2.0\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/elements/1.1/\" xmlns:taxo=\"http://purl.org/rss/1.0/modules/taxonomy/\">\n");
		
		
		$this->printChannel();

		print("</rss>\n");
	}
	
	function printChannel(){
		
		print("<channel>\n");
		if($this->printheadenable == true) $this->printhead();
		foreach($this->items as $item){
			while (list($name,$value) = each($item)) {
				$this->getnextdepth($name, $value);
			}			
		}
		print("</channel>\n");
	}
	

	function getnextdepth($name, $value){
		if(is_numeric($name)){//$name 이 숫자(key값이 없는 배열일경우)일경우 에러방지용
			$this->subchannel++;
			$name = "channel_sub".$this->subchannel;
		}
		if(is_array($value)){
			printf("<%s>\n",$name); 
			while (list($name1,$value1) = each($value)) {
				if(is_array($value1)){
					$this->getnextdepth($name1, $value1);
				}else{
					//$value1 = htmlspecialchars($value1);
					$name1 = strip_tags($name1);
					if($name1 == "link") $value1 = htmlspecialchars($value1);
					if($name1 == "guid") $value1 = htmlspecialchars($value1);
					switch($name1){
						case "title":
						case "description":
							printf("<%s><![CDATA[%s]]></%s>\n",$name1,$value1,$name1); 
						break;
						default:
							printf("<%s>%s</%s>\n",$name1,$value1,$name1); 
						break;
					}
				}
				
			}
			printf("</%s>\n",$name); 
		}else{
			//$value = htmlspecialchars($value);
			printf("<%s>%s</%s>\n",$name,$value,$name); 
		}
	}

	function printhead(){
		print("<title> ".$this->title." </title>\n");
		print("<link>".$this->link."</link>\n");
		print("<description>".$this->description."</description>\n");
		print("<language>".$this->language."</language>\n");
		print("<copyright>".$this->copyright."</copyright>\n");
		print("<pubDate>".date("r")."</pubDate>\n");
	}
	
	function addItem($item){
		array_push($this->items,$item);
	}
}	

####################################################################################
#### XML 사용예
####################################################################################
/*

##### xml 생성 예
/wizboard/rss.php 참조

$xml_c = new xmlcreate();
//$val1["body"] = eregi_replace("[!@#$%^&()_+|]", "", $val1["body"]); 처럼 사용하여 특수문자 제거
//xml 로 생성코자 하는 내용을 배열에 넣는다
for($i=0; $i<10; $i++){//
	item = array("ordno"=> $ordno,"pname"=> $pname,"pprice"=> $pprice);
	$xml_c->addItem($item);
}

//다차원배열을 사용할경우
for($i=0; $i<10; $i++){//
	$item = array("item"=>array("title"=> $title,"link"=> $link,"guid"=> $guid,"description"=> $description,"pubDate"=> $pubDate));
	$xml_c->addItem($item);
}

$xml_c->printheadenable = true;//title등을 넣을 경우 (rss용)
$xml_c->title = "shop-wiz.com";
$xml_c->link = "http://www.shop-wiz.com";
$xml_c->description = "free solution";
$xml_c->language = "ko";
$xml_c->copyright = "Copyright(c) Shop-wiz.com. All Rights Reserved.";
$xml_c->pubDate = "shop-wiz.com";




$xml_c->outputXml();//xml 파일로 출력한다.




##### xml 파싱예
	$xml_p = new xmlparse();
	
	$file = "http://www.shop-wiz.com/xml/xml_test.php";//현재 xml이 존재하는 곳의 파일 url을 넣는다.
	$fp = fopen($file, "r") or die("$file not found");
	while ($data = fread($fp, 4096)) {
		$xml_p->parse($data);//특정값을 배열에 넣는다.
	}

	foreach($xml_p->filename["ordno"] as $key => $value){	
		$orderno 	= trim($xml_p->filename["ORDNO"][$key]);//값을 가져올때 대소문자에 유의한다.
		$pname 	= trim($xml_p->filename["PNAME"][$key]);
		$pprice 	= trim($xml_p->filename["PPRICE"][$key]);

	}

*/
?>