<?php
/**
* 기본 설정 파일
*
* @filename : common/skydir_init.php
* @version  : v 1.3 2003.04.03 13:43:22  : 기본설정 자동화
*             v 1.2 2003.03.05 10:41:22 
*             v 1.0 2002.11.06 16:04:34
* @author   : nsl <smpoem@magicn.com>
*/

// os 가 원도우인가 ?
function isOsWin() {

    if (substr(PHP_OS, 0, 3) == 'WIN')
        return true;
    else 
        return false;
}

// PEAR.php 참고함.
// 시스템 os 구하기
function getSystemOs() {

    if ( isOsWin() ) {

        define('_OS_WINDOWS', true);
        define('_OS_LINUX', false);
        define('_DIR_SEP_PATH', "\\");

    } else {

        define('_OS_LINUX', true);
        define('_OS_WINDOWS', false);
        define('_DIR_SEP_PATH', "/"); // 원도우 + apache 에서 설치시에만
    }
}

getSystemOs();


//^^^^^^^^^^^^^^ 경로 자동 설정 ^^^^^^^^^^^^^^^^^^^^^^^^

// nDir 설치된 서버상의 절대 경로  예) /home/userid/public_html/ndir
if (_OS_LINUX) {
      $_SKYDIR_PATH =  ereg_replace("\/common\/skydir_init\.php", "", __FILE__);
//    $_SKYDIR_PATH =  preg_replace("/\/common\/skydir_init\.php/", "", __FILE__);
} else {
//      $_SKYDIR_PATH =  ereg_replace("\/common\/skydir_init\.php", "", __FILE__);
    $_SKYDIR_PATH =  preg_replace("/" . preg_quote("\\common\\skydir_init.php") . "/", "", __FILE__);
}

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// 기본 환경설정 체크
include $_SKYDIR_PATH . '/php/init_check.php';

// 환경 파일을 읽는다
function getConfigFileSub($filename) {

    global $dcfg;

    $file = $dcfg->configDir . '/' . $filename;

    if (!is_file($file)) return false;
    if (!is_readable($file)) return false;

    $fp = fopen($file, 'r');
    if (!$fp) return false;

    $content = fread($fp, filesize($file));

    fclose($fp);

    return  unserialize($content);
}


// 환경설정 파일
include $_SKYDIR_PATH . '/common/skydir_config.php';

//                       uconfig.php
$ucfg = getConfigFileSub($dcfg->uconfigFile);

// 사용함수 모음
include $_SKYDIR_PATH  .'/common/skydir_func.php';

// 사용자 환경설정 파일
include $_SKYDIR_PATH . '/common/skydir_rconfig.php';


// 파일 클래스
include $_SKYDIR_PATH  .'/class/sky_file_class.php';

// 이미지크기설정 클래스
include $_SKYDIR_PATH . '/class/sky_imgsize_class.php';

// ftp 클래스
include $_SKYDIR_PATH  .'/class/sky_ftp_class.php';

// 파일 보기 가능한 확장자를 배열로 text
$textViewExt = $rcfg->textViewExt;

// 파일 보기 가능한 확장자를 배열로 img
$imgViewExt = explode("┃", $rcfg->imgViewExt);

// MB 단위로 변경 (이미지 미리불어올 제한 용량)
$rcfg->imgReloadMaxSizeReal = $rcfg->imgReloadMaxSize . '000000';

// 언어설정 파일
include $_SKYDIR_PATH . '/lang/' . $rcfg->language . '.php';

// 로그인 체크
if ( !ereg("index.php|login.php|logout.php|install.php|x.php", $_SERVER['PHP_SELF']) )
    isUserLoginCheck();

@extract($_REQUEST, EXTR_SKIP);
?>