<?php
/**
* 사용자 환경설정
*
* @filename : common/skydir_rconfig.php
* @version  : v 1.0 2002.11.06 17:40
* @author   : nsl <smpoem@magicn.com>
*/

settype($rcfg, 'object'); 

//^^^^^^^^^^^^^^^^^^^^^ 웹상에서 파일실행, 보기 설정 ^^^^^^^^^^^^^^^^^^^^
// 여기에 설정한 조건이 맞는 디렉토리에서만 실행, 보기가 가능하다


//^^^^^^^^^^^^^^^^^^^^^ root, 시작 디렉토리 설정 ^^^^^^^^^^^^^^^^^
// root 지정
$rcfg->initDirRoot  = '/';

// 사이트 도메인
$rcfg->initDomain  = $ucfg->initDomain;

// 파일 경로에서 이 경로를 제외하고 실행하게 된다.
// n 이 설치된 사이트 홈 절대경로
$rcfg->initDocumentRoot = $ucfg->initDocumentRoot;

// left, right 시작위치 지정
$rcfg->initDirRight =  '/' . $ucfg->initDirRight;

$rcfg->initDirVir   = ereg_replace($ucfg->initDocumentRoot, "", $ucfg->initDirRight);
//^^^^^^^^^^^^^^^^^^^^^ /root, 시작 디렉토리 설정 ^^^^^^^^^^^^^^^^^

// 초기 사용자 정보
$rcfg->superID = $ucfg->superID;
$rcfg->superPW = $ucfg->superPW;

if ( eregi("MSIE", $_SERVER['HTTP_USER_AGENT']) ) {

    $rcfg->winColor       = 'ButtonFace'; // 'buttonface'; //'#D4D0C8'; // 창 배경색
    $rcfg->winBorderColor = 'ButtonFace'; // 프레임 테두리색
    $rcfg->buttonColor    = 'ButtonFace'; // 버튼 색
} else {

    $rcfg->winColor       = '#D4D0C8'; // 'buttonface'; //'#D4D0C8'; // 창 배경색
    $rcfg->winBorderColor = '#D4D0C8'; // 프레임 테두리색
    $rcfg->buttonColor    = '#D4D0C8'; // 버튼 색
}


// 파일 보기 가능한 확장자 (notext -> 파일확장자가 없는 것)
$rcfg->textViewExt = $ucfg->textViewExt;

// 이미지 확장자
$rcfg->imgViewExt = "gif┃jpg┃bmp┃png";

// 언어
$rcfg->language = $ucfg->language;

// 환경설정 > 선택사항
$rcfg->isLog = $ucfg->isLog; // 로그 남기기 유무
$rcfg->isOnClickFolderOpen = $ucfg->isOnClickFolderOpen; // 한번 클릭으로 폴더열기


// 환경설정 > 배경이미지
$rcfg->rightBgImage = $ucfg->rightBgImage; // 이미지
$rcfg->rightBgImageRepeat = $ucfg->rightBgImageRepeat; // 반복
$rcfg->rightBgImagePos = $ucfg->rightBgImagePos; // 위치
$rcfg->rightBgImageOpacity = $ucfg->rightBgImageOpacity; // 투명도

// 파일, 디렉토리 검색시 옵션
$rcfg->searchFileOption    = $ucfg->searchFileOption;     // 파일
$rcfg->searchFolderOption  = $ucfg->searchFolderOption;   // 디렉토리
$rcfg->searchEngOption     = $ucfg->searchEngOption;     // 대소문자 구분
$rcfg->searchSubdirOption  = $ucfg->searchSubdirOption;     // 하위디렉토리

// 오른쪽 프레임 정렬값
$rcfg->sortField = $ucfg->sortField;
$rcfg->sortKey   = $ucfg->sortKey;

// 전체 창 크기
$rcfg->windowsWidth  = $ucfg->windowsWidth;
$rcfg->windowsHeight = $ucfg->windowsHeight;

// 최소 실행 크기
$rcfg->minWindowsWidth  = 300;
$rcfg->minWindowsHeight = 300;

// 마지막 원도우 크기로 실행
$rcfg->isWindowInitSize = $ucfg->isWindowInitSize;

// 왼쪽 프레임 넓이
$rcfg->leftFrameWidth = 200;

// 왼쪽 하단 프레임 높이
$rcfg->leftBottomFrameHeight= 200;


// 미리 읽을 이미지 로딩 최대 갯수
$rcfg->imgReloadMax = $ucfg->imgReloadMax;

// 단위 MByte, 1M당 약 20M의 메모리 소요
// 메모리는 유동적
$rcfg->imgReloadMaxSize = $ucfg->imgReloadMaxSize;

// 이미지 모드에서 이미지 출력 크기
$rcfg->imgThumbnailWidth  = $ucfg->imgThumbnailWidth;
$rcfg->imgThumbnailHeight = $ucfg->imgThumbnailHeight;

// 이미지 모드
$rcfg->isImageMode = $ucfg->isImageMode;

// 오른쪽 프레임 크기
$rcfg->rightFrameWidth  = $ucfg->rightFrameWidth;
$rcfg->rightFrameHeight = $ucfg->rightFrameHeight;

$rcfg->nameWidth = 200;
$rcfg->webWidth  = 25;
$rcfg->viewWidth = 25;
$rcfg->renameWidth = 25;
$rcfg->deleteWidth = 25;
$rcfg->sizeWidth = 90;
$rcfg->timeWidth = 120;
$rcfg->permsWidth = 80;
$rcfg->ownerWidth = 100;
$rcfg->titleWidth = '100%';

//^^^^^^^^^^^^^^^^^^^^ ftp 접속 정보 ^^^^^^^^^^^^^^^^^^^^
$rcfg->ftpHost   = $ucfg->ftpHost;
$rcfg->ftpPort   = $ucfg->ftpPort;
$rcfg->ftpUserID = $ucfg->ftpUserID;
$rcfg->ftpUserPW = $ucfg->ftpUserPW;
$rcfg->ftpPassiveMode = $ucfg->ftpPassiveMode;

// 파일 올릴때 덮어 쓰기 유무
$rcfg->isFileOverwrite = $ucfg->isFileOverwrite;

// 파일 전송유형
$rcfg->fileTransferType = $ucfg->fileTransferType;

// 사용자 계정의 홈 디렉토리 구함
$rcfg->userHomeDir = getUserHomeDir($rcfg->ftpUserID);

?>