<?php
/**
* 오른쪽 프레임
*
* @filename : main/right.php
* @version  : v 1.0 2003.07.18 18:26:33
* @author   : nsl <smpoem@magicn.com>
* @info 
*     - 디렉토리, 파일은 각각 정렬 된다.
*     - 출력할 내용을 일단 배열에 넣고 -> 정렬한 후 -> 출력한다
*/

// @param string $cd : 디렉토리

// $cd :  /test/img   : 값
// $curdir = /home/test/public_html/ + /test/img

$_SKYDIR_URL = '../';

// 기본 설정 초기화
include '../common/skydir_init.php';

// 이미지크기 설정 클래스
$imgs = new SkyImgsize;

// ftp class 초기화
$ftp = new SkyFtp($rcfg->ftpHost, $rcfg->ftpPort, $rcfg->ftpUserID, $rcfg->ftpUserPW);

// ftp 연결
if (!$ftp->ftpLogin()) {

    $ftp->ftpClose();
    notConnectMsg();
    exit;
}

if (!isset($sortField) && !isset($sortKey)) {

    $sortField = $rcfg->sortField;
    $sortKey = $rcfg->sortKey;
}

// 정렬값을 변경했다면 -> 환경설정 저장
if ($sorton == 1) {
    
    $ucfg->sortField = $sortField;
    $ucfg->sortKey   = $sortKey;

    setConfigFile($dcfg->uconfigFile, $ucfg);

}

$startTime = getMicroTime();

// 배경이미지
if ($rcfg->rightBgImage)
    $rcfg->rightBgImage = '../' . $dcfg->bgImageDir . '/' . $rcfg->rightBgImage; //

// 디렉토리 값이 없으면 초기 경로로 설정
if (empty($cd)) {

    $cdTemp = $rcfg->initDirRight;
} else {
    
    //                            
    if ($rcfg->initDirRight != "/" && $changeDir != "ok") {

        $cdTemp = $rcfg->initDirRight . $cd;
    } else {

        $cdTemp = $cd;
    }
}

$curdir =  $cdTemp;

// top 프레임에서 출력할 위치 경로
$topDirPos = getDirPos($cd);

// 웹에서 파일을 실행할 수 있는 디렉토리인가 ?
// 절대 경로만 검사 (도메인은 체크 안함)
$isWebRun = isWebRun($curdir);

// 디렉토리 이동
$ftp->ftp_chdir($curdir);


// 현재 디렉토리의 디렉토리목록, 파일 목록 구하기
list($curDirList, $curFileList) = $ftp->ftp_rawlist($ftp->ftp_pwd());

// ftp close
$ftp->ftpClose();

$z = 0;
foreach($curDirList as $qKey => $qVal) {

    // 디렉토리명 (순수한)
    $dn = $qVal['name']; 

    $dirname[$z] = $dn;                 // 디렉토리명 (순수한)
    $dirnameTemp[$z] = strtolower($dn); // 디렉토리명 (정렬용)

    if ($dn != "." && $dn != "..") {

    	$dirLink[$z] =  $cd . "/" . urlencode($dn); // 링크 주소 배열

        $dirsizeTemp[$z] = $dn; // 디렉토리 크기로 정렬시 -> 파일이름으로 정렬한다

        $dirsize[$z] = $ftp->getFileSizeCons($qVal['size'], 2, false); // 크기
        $dirtime[$z] = $ftp->getFileTimeCons($qVal['date']); // 수정한 날짜
        $dirperms[$z] = $qVal['rights'];  // d . rw-r--r-- 퍼미션
        $dirowner[$z] = $qVal['user'];    // 소유자
        $dirgroup[$z] = $qVal['group'];   // 그룹

    } else {

        if ($dn == ".") {

        	$dirLink[$z] =  $cd; // . "/" . urlencode($dn); // 링크 주소 배열

        } else if ($dn == ".."  && !empty($cd)) {

            // /home/test/user -> /home/test
            $dirLink[$z] = substr($cd, 0, strrpos($cd, '/'));
        }

        $dirsizeTemp[$z] = $dn; // 디렉토리 크기로 정렬시 -> 파일이름으로 정렬한다

        $dirsize[$z] = '';  //$ftp->getFileSizeCons($qVal['size'], 2, false); // 크기
        $dirtime[$z] = '';  //$ftp->getFileTimeCons($qVal['date']); // 수정한 날짜
        $dirperms[$z] = ''; //$qVal['rights'];  // d . rw-r--r-- 퍼미션
        $dirowner[$z] = ''; //$qVal['user'];    // 소유자
        $dirgroup[$z] = ''; //$qVal['group'];   // 그룹    

    }

    $z++;
}


//^^^^^^^^^^^^^^^^^^^^^ 디렉토리 목록 구하기 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


//^^^^^^^^^^^^^^^^^^^^^ 디렉토리 정렬 부분 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// 정렬필드 선택
if (!isset($sortField)) $sortField = 'name';

// 정렬 기준 값을 $initdir 에 ...
if      ($sortField == 'name')  $initdir = &$dirnameTemp;
else if ($sortField == 'size')  $initdir = &$dirsize; //&$dirsizeTemp;
else if ($sortField == 'time')  $initdir = &$dirtime;
else if ($sortField == 'perms') $initdir = &$dirperms;
else if ($sortField == 'owner') $initdir = &$dirowner;

// 정렬 조건
if (!isset($sortKey)) $sortKey = 'asc';

if ($sortKey == 'desc') {

    @arsort($initdir); // 배열정렬 배열 키값을 유지하면서
    $sortKeyUn = 'asc';  // 다음 정렬값
    $sortKeyMark = 6;    // 자바스크립트에서 표시 마크
} else {

    @asort($initdir); 
    $sortKeyUn = 'desc';
    $sortKeyMark = 5;
}
//^^^^^^^^^^^^^^^^^^^^^ /디렉토리 정렬 부분 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^



//^^^^^^^^^^^^^^^^^^^^^ 디렉토리 출력내용 구하기 ^^^^^^^^^^^^^^^^^^^^^^^^^^^
// 출력
$number = 0;

// 전체 디렉토리 수
$dirTotal = count($initdir);
$dirTotalReal = $dirTotal - 2; // . , .. 제외

// 디렉토리가 있을 경우만 출력
if ($dirTotal) { 

    foreach ($initdir as $dirKey => $dirValue) {

        $number ++;
        $layerID = 'right' . $number;

        $dirnamePrint = $dirname[$dirKey];            // 디렉토리명

        $dirLinkPrint = $dirLink[$dirKey]; //urlencode($dirLink[$dirKey]); // 링크주소

    	$dirsizePrint = $dirsize[$dirKey];            // 크기
    	$dirtimePrint = $dirtime[$dirKey];            // 시간 
//    	$diriconPrint = $diricon[$dirKey];            // 아이콘은 모두 똑같으므로 ..
    	$dirpermsPrint = $dirperms[$dirKey];          // 퍼미션
        $dirownerPrint = $dirowner[$dirKey];          // 소유자

        if ($dirnamePrint == "." || $dirnamePrint == "..")
            $dirpermsPrint = "drwxrwxrwx";


        //  퍼미션 첫번째 것이 7이 아니면 접근할 수 없다.
        if ($ftp->isDirAccessPerms($ftp->getStrPermsAll(substr($dirpermsPrint, 1)), $dcfg->dirPerms)) {
        // 접근 가능할 경우

             // 마우스 클릭시 실행주소
            if ($rcfg->isOnClickFolderOpen)
                 $dLink = "OnClick=\"rightDblClick('$dirLinkPrint')\"";
            else
                 $dLink = "OnDblClick=\"rightDblClick('$dirLinkPrint')\"";

            if ($dirnamePrint != '.' && $dirnamePrint != '..') {

                $dirLinkPrintDel = urldecode($dirLinkPrint);

                // 디렉토리이름 변경
                $dLinkRename = "<a href=\"javascript:dirRenameWin('dir_rename', '400', '250', '$dirnamePrint')\" title=''>" . 
                              "<img src='$dcfg->iconRename' width=16 height=16 border=0 align=absmiddle></a>";

                // 디렉토리 삭제
                $dLinkDelete = "<a href=\"javascript:dirDelete('$dirnamePrint', '$dirLinkPrintDel')\" title=''>" . 
                               "<img src='$dcfg->iconDelete' width=16 height=16 border=0 align=absmiddle></a>";
            }

             $dBgColor = '';
             $layerIDTemp = '';

        } else {
        // 접근 불가일 경우
           
             // 마우스 더블클릭 => 접근 불가!
             $dLink = "";

             // 접근 금지 디렉토리는 배경색을 다르게 표시
             $dBgColor = ' bgcolor=' . $dcfg->dirNotBgcolor; 

            // 디렉토리이름 변경
            $dLinkRename = "<img src='$dcfg->iconRenameGray' width=16 height=16 border=0 align=absmiddle>";

            // 디렉토리 삭제
            $dLinkDelete = "<img src='$dcfg->iconDeleteGray' width=16 height=16 border=0 align=absmiddle>";

             // 접근 금지 배경색이 계속 유지 되도록 레이어를 ...
             $layerIDTemp = "<div id='$layerID'></div>";
             $layerID = '';
        }

        if ($dirnamePrint == "." || $dirnamePrint == "..")
            $dirpermsPrint = "";

     //$dirpermsPrint = 'd' . SkyFile::getPermsStrAll(trim($dirpermsPrint));

    // 출력할 내용
	$tplList .="
       <tr id='$layerID'>
          <td height='15' $dBgColor style=\"width:$rcfg->nameWidth;cursor: default;\" $dLink  OnClick=\"setBgcolor('$number');setLeftBottomImgHide();\"><img src='$dcfg->iconFolder' width=16 height=16 align='absmiddle' border='0'>&nbsp;$dirnamePrint
            $layerIDTemp  
          </td>
          <td $dBgColor style='width:$rcfg->webWidth'>&nbsp;</td>
          <td $dBgColor style='width:$rcfg->viewWidth'>&nbsp;</td>
          <td $dBgColor style='width:$rcfg->renameWidth'>$dLinkRename</td>
          <td $dBgColor style='width:$rcfg->deleteWidth'>$dLinkDelete</td>
          <td $dBgColor style='width:$rcfg->sizeWidth;' align='right'>$dirsizePrint</td>
          <td $dBgColor style='width:$rcfg->timeWidth;' align='center'>$dirtimePrint</td>
          <td $dBgColor style='width:$rcfg->permsWidth;'>$dirpermsPrint</td>
          <td $dBgColor style='width:$rcfg->ownerWidth;'>$dirownerPrint</td>
          <td width='*'>&nbsp;</td>
       </tr>";

    } // foreach End

} // if End
//^^^^^^^^^^^^^^^^^^^^^ /디렉토리 출력내용 구하기 ^^^^^^^^^^^^^^^^^^^^^^^^^^^

$tplList .= "\n\n<!-- ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ 파일 출력 부분 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ -->\n\n";


//^^^^^^^^^^^^^^^^^^^^^^^^^^ 파일 목록 구하기 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// 출력할 내용을 먼저 배열에 모두 넣는다 -> 아래서 정렬후 -> 출력한다


$z = 0;
foreach($curFileList as $qKey => $qVal) {

    // 파일이름
    $fn = $qVal['name']; 

    $filename[$z] = $fn;                   // 파일이름 (순수함)
    $filenameTemp[$z] = strtolower($fn);   // 파일이름 (정렬용)

    $fileicon[$z] = getFileIcon($fn); // 파일 아이콘
    $fileExt[$z] = strtolower($ftp->getFileExtension($fn)); // 파일 확장자

    //
    $filelink[$z] = $cd . '/' . $fn; // 파일링크 절대경로 주소 -> 파일 내용보기용

    // 파일링크 주소 (웹브라우저에서 보기 위한 것)
//    $filelinkWeb[$z] =  $rcfg->initDomain .  $rcfg->initDirVir .  $cd . '/' . $fn;
    $filelinkWeb[$z] =  $rcfg->initDomain .  $cd . '/' . $fn;


    $filesizeTemp[$z] = $qVal['size']; // 파일 사이즈 정렬용
    $filesizeTotal   += $filesizeTemp[$z]; // 하단 출력용
    $filesize[$z]     = $ftp->getFileSizeCons($qVal['size'], 2, false);  // 파일 사이즈 출력용

    $filetime[$z] = $ftp->getFileTimeCons($qVal['date']); // 수정한 날짜

    $fileperms[$z] = $qVal['rights'];     // 파일 퍼미션

    $fileowner[$z] = $qVal['user']; // 파일 소유자
    $filegroup[$z] = $qVal['group']; // 파일 group



        $fileNameList[]  = $qVal['name'];
        $fileSizeList[]  = $qVal['size'];
        $filePermsList[] = $qVal['rights']; // rw-r--r--
        $fileUserList[]  = $qVal['user'];
        $fileGroupList[] = $qVal['group'];
        $fileDateList[]  = date("Y-m-d H:i:s", $qVal['date']); // 1067559420
        $fileDirList[]   = $qVal['is_dir']; // d

    // 이미지 파일이면 웹브라우저에서 미리 불러오기 위해 일단 목록을 저장
    // 이미지를 미리 불러오지 않으면 이미지 미리보기시 두 번 클릭해야 한다
    // (단, 실제 이미지 크기로 보면 문제가 없으나 -> 창 크기에 맞게 조정해서 보므로 ...
    //     이미지파일            &&  웹에서 보기 가능 한가 ?
    if (isViewImg($fileExt[$z])  && $isWebRun) {

       // 이미지 파일의 크기 총합 누적
       $filesizeImgTotal += $filesizeTemp[$z];

       //    현재파일크기 합 < 이미지 미리불어오기 총 제한 크기 && 갯수 < 제한 갯수
       if ($filesizeImgTotal < $rcfg->imgReloadMaxSizeReal && $z < $rcfg->imgReloadMax) {

           $fileImageReload[$fn] = $filelinkWeb[$z];
       }

       $isFileImage[$z] = true; // 이미지 파일인지 유무
    }else {

       $isFileImage[$z] = false;
    }
    
    $z++;
} // foreach End
//^^^^^^^^^^^^^^^^^^^^^^^^^^ /파일 목록 구하기 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// 미리 읽어들인 이미지 갯수
$fileImageReloadCount = count($fileImageReload);

// 파일들의 총 크기합
$filesizeTotal    = $ftp->getFileSizeCons($filesizeTotal, 2, false); // 하단 출력용


//^^^^^^^^^^^^^^^^^^^^^^^^^ 파일 정렬 부분 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

//^^^^^^^^^^^^^ 정렬할 필드 선택 ^^^^^^^^^^^^^^^^^
if (!isset($sortField)) $sortField = 'name';

if      ($sortField == 'name') {
    
    $initfile = &$filenameTemp;

    $sortArName = "<span class='sortArrow' id='startArrow'>$sortKeyMark</span>"; // 정렬 마크
}else if ($sortField == 'size') {
    
    $initfile = &$filesizeTemp;
    $sortArSize = "<span class='sortArrow' id='startArrow'>$sortKeyMark</span>";
}else if ($sortField == 'time') {
    
    $initfile = &$filetime;
    $sortArTime = "<span class='sortArrow' id='startArrow'>$sortKeyMark</span>";
}else if ($sortField == 'perms') {
    
    $initfile = &$fileperms;
    $sortArPerms = "<span class='sortArrow' id='startArrow'>$sortKeyMark</span>";
}else if ($sortField == 'owner') {
    
    $initfile = &$fileowner;
    $sortArOwner = "<span class='sortArrow' id='startArrow'>$sortKeyMark</span>";
}


//정렬 조건에 따른 정렬 
if ($sortKey == 'desc') {

    @arsort($initfile);
} else {

    @asort($initfile);
}
//^^^^^^^^^^^^^^^^^^^^^^^^^ /파일 정렬 부분 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^



//^^^^^^^^^^^^^^^^^^^^^^^^^ 파일 출력 부분 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
// 파일 갯수
$fileTotal = count($initfile);

//레이어 총 갯수 = 디렉토리갯수 + 파일 갯수
$layerTotal = $dirTotal + $fileTotal;

// 파일이 있을 경우만 출력
if ($fileTotal) { 

// 이미지 크기 MAX 값 설정
$imgs->setWidthMax($rcfg->imgThumbnailWidth);
$imgs->setHeightMax($rcfg->imgThumbnailHeight);
$imgRow = 0; // 이미지 가로 출력 갯수
$imgCol = 0; // 이미지 세로 출력 갯수
$imgCount = 0;

//  가로 갯수        =     프레임크기         / ( 이미지출력 width        + 두께 + 여백)
$dcfg->rightImageCol = round($rcfg->rightFrameWidth /  ($rcfg->imgThumbnailWidth  + 10 + 10));
$dcfg->rightImageRow = round($rcfg->rightFrameHeight / ($rcfg->imgThumbnailHeight + 10 + 10));


    foreach ($initfile as $fileKey => $fileValue) {

        $number ++;
        $layerID = 'right' . $number;

        $filenamePrint = $filename[$fileKey];     // 파일이름
    	$filesizePrint = $filesize[$fileKey];     // 파일크기
    	$filetimePrint = $filetime[$fileKey];     // 파일 시간
    	$fileiconPrint = $fileicon[$fileKey];     // 파일 아이콘
        $fileExtPrint  = $fileExt[$fileKey];      // 파일 확장자
    	$filepermsPrint = $fileperms[$fileKey];   // 파일 퍼미션
        $fileownerPrint = $fileowner[$fileKey];   // 파일 소유자
    	$filelinkPrint = $filelink[$fileKey];      // 파일 링크 절대경로

        $filelinkWebPrint = $filelinkWeb[$fileKey];  // 웹 URL  /html/new.html ...

        $isFileImageCheck = $isFileImage[$fileKey];// ture : 이미지 파일

         // 링크 -> 파일 보기 : 서버상의 절대경로
         //      -> Web       : 웹상의 위치

        // 루트 부터 탐색할 경우 -> 
        // 프로그램 설치된 웹사이트에 왔을때 -> 파일을 익스프롤러에서 실행가능하도록
        // 웹상에서 접근하는 디렉토리이면 --> 링크 허옹

        // 웹에서 실행할 수 있는 디렉토리이면
        if ($isWebRun) {

             // 파일 링크
             $fLink = "window.open('$filelinkWebPrint', '')";

             // 웹에서 파일 실행
             $fLinkWebRun = "<a href='#' OnClick=\"$fLink\" title=''>" . 
                            "<img src='$dcfg->iconWebview' width=16 height=16 border=0 align=absmiddle></a>";

            //  이미지 파일이면 OnClick 시 클릭시 => 이미지 미리보기 링크
            if ($isFileImageCheck ) {

                $fLinkImage = "imgPreview('$filelinkWebPrint', '$filenamePrint')";
            } else {
             
                // 이미지파일이 아니면 => 빈이미지 링크
                $fLinkImage = "setLeftBottomImgHide()";
            }

        } else {
        // 웹에서 실행할 수 있는 디렉토리가 아니면

             // 파일 링크 (파일 더블 클릭시)
             $fLink = "errMsgNotWeb()";

             // 웹에서 파일 실행 아이콘 클릭시 => 실행불가
             $fLinkWebRun = "<img src='$dcfg->iconWebviewGray' width=16 height=16 border=0 align=absmiddle>"; 
             
                               //"<a href='#' OnClick=\"javascript:errMsgNotWeb()\"  title=''>". 
                               //"<img src='$dcfg->iconWebviewGray' width=16 height=16 border=0 align=absmiddle></a>";
        }

        
        //  퍼미션 세번째 것이 4 보다 작으면 접근할 수 없다.(웹에서 실행하는 것만)
        //  FTP 함수를 이용하는 것은 제한없음
        if ($ftp->isFileAccessPerms($ftp->getStrPermsAll($filepermsPrint), $dcfg->filePerms)) {
        // 접근 가능일 경우 처리

             // 파일 링크
             $fLink = $fLink;

             // 아스키(text) 파일 내용 보기 링크
             if (isViewText($fileExtPrint)) {

                 $fLinkView = "<a href=\"javascript:fileViewWin('$dcfg->fileRead?file=$filelinkPrint', -1, -1)\" title=''>" . 
                              "<img src='$dcfg->iconFileview' width=16 height=16 border=0 align=absmiddle></a>";
             } else {

                 // 파일 보기 아이콘 클릭시
                 $fLinkView = "<img src='$dcfg->iconFileviewGray' width=16 height=16 border=0 align=absmiddle>"; 
             }

            // 파일이름 변경
            $fLinkRename = "<a href=\"javascript:fileRenameWin('file_rename', '400', '250', '$filenamePrint')\" title=''>" . 
                              "<img src='$dcfg->iconRename' width=16 height=16 border=0 align=absmiddle></a>";

            // 파일 삭제
            $fLinkDelete = "<a href=\"javascript:fileDelete('$filenamePrint', '$filelinkPrint')\" title=''>" . 
                              "<img src='$dcfg->iconDelete' width=16 height=16 border=0 align=absmiddle></a>";

             $fBgColor = '';
             $layerIDTemp  = '';

        } else {
        // 접근 불가일 경우 처리

             // 접근할 수 없는 메세지
             $errorMsgPerms = "* Permissions : $filepermsPrint !";

             // 파일 링크
             $fLink = "alert('$errorMsgPerms')";

             // 파일 보기 아이콘 클릭시
             $fLinkView = "<img src='$dcfg->iconFileviewGray' width=16 height=16 border=0 align=absmiddle>";


            // 파일이름 변경
            $fLinkRename = "<a href=\"javascript:fileRenameWin('file_rename', '400', '250', '$filenamePrint')\" title=''>" . 
                              "<img src='$dcfg->iconRename' width=16 height=16 border=0 align=absmiddle></a>";

            // 파일 삭제
            $fLinkDelete = "<a href=\"javascript:fileDelete('$filenamePrint', '$filelinkPrint')\" title=''>" . 
                              "<img src='$dcfg->iconDelete' width=16 height=16 border=0 align=absmiddle></a>";

            // 파일이름 변경
            //$fLinkRename = "<img src='$dcfg->iconRenameGray' width=16 height=16 border=0 align=absmiddle>";

            // 파일 삭제
            //$fLinkDelete = "<img src='$dcfg->iconDeleteGray' width=16 height=16 border=0 align=absmiddle>";

             //^^^^^^^^^^^^^^^^^^^^ 웹에서 실행 아이콘 재설정 ^^^^^^^^^^^^^^^^^
             $fLinkWebRun = "<img src='$dcfg->iconWebviewGray' width=16 height=16 border=0 align=absmiddle>";

             $fLinkImage = "setLeftBottomImgHide()";
             //^^^^^^^^^^^^^^^^^^^^ /웹에서 실행 아이콘 재설정 ^^^^^^^^^^^^^^^^^
             

             // 배경색
             $fBgColor = ' bgcolor=' . $dcfg->dirNotBgcolor;

             // 클릭했을 때 배경색이 유지 되도록 레이어를 ...
             $layerIDTemp = "<div id='$layerID'></div>";
             $layerID = '';
        }

         // 마우스 클릭시 실행주소
        if ($rcfg->isOnClickFolderOpen)
            $fLinkOnClick = ";" . $fLink;
        else
            $fLinkDblClick = $fLink;

        //$filepermsPrint = '-' . SkyFile::getPermsStrAll(trim($filepermsPrint));

        //  이미지 모드        &&    이미지 파일 (2군데있음) 
        if ($rcfg->isImageMode && $isFileImageCheck ) {


            // 초기 시작 테이블 부분
            if (!$imgCount) {

                $tplList .= "<tr>\n" .
                            "  <td colspan=10>\n" .
                            "    <table border=0 cellpadding=3 cellspacing=0 bgcolor=$rcfg->winColor>\n" .
                            "       <tr>\n";
            }

            $imgRow ++;
            $imgCol ++;
            $imgCount ++;

            // 이미지 크기를 구하고
            $imgSize = getImageSize($rcfg->userHomeDir . $curdir ."/" . $filenamePrint);

            // 이미지 크기를 재조정
            $imgs->getImageSize($imgSize[0], $imgSize[1]);

            //  출력 갯수 <= 미리 읽어온 이미지 갯수
            if ($imgCount <= $fileImageReloadCount) {

                $imgAlt = " $filenamePrint &#13; $imgSize[0] x $imgSize[1] &#13; $filesizePrint &#13; $filetimePrint";
                $tplList .= "<td id='$layerID' align=center title='$imgAlt'>\n" .
                            "<table class=photoBorder border='1' cellspacing=0 " .
                            "bgcolor=$rcfg->winColor width=$rcfg->imgThumbnailWidth height=$rcfg->imgThumbnailHeight>\n" .
                            "<tr>\n" .
                            "  <td align=center OnClick=\"setBgcolor('$number');$fLinkImage $fLinkOnClick\">" .
                            "<img src='$fileImageReload[$filenamePrint]' width=$imgs->newImageWidth " .  
                            "height=$imgs->newImageHeight border=0 align=absmiddle>" . 
                            "  </td>\n" .
                            "</tr>\n" .
                            "</table>\n" .
                            "</td>\n";
            } else {


                // "이미지 최대 출력 갯수  최대 출력 용량 초과 환경설정에서 설정 변경가능함";
                $imgAlt = $lg->configImageOverMsg;
                $tplList .= "<td bgcolor=$rcfg->winColor width=100% height=$rcfg->imgThumbnailHeight " .
                            "align=center title='$imgAlt'>$dcfg->pgName</td>\n";
            }

            if ($imgCol == $dcfg->rightImageCol) {

                $tplList .= "</tr>\n";
                $tplList .= "<tr>\n";

                $imgCol = 0;
            }

           $isFileImageCheckLast = $isFileImageCheck;
        } else if (!$rcfg->isImageMode ) {
        // 파일 목록 모드

        	$tplList .="
            <tr id='$layerID'>
              <td $fBgColor style='width:$rcfg->nameWidth;cursor: default;' height=15 
            OnDblClick=\"$fLinkDblClick\" OnClick=\"setBgcolor('$number');$fLinkImage $fLinkOnClick\" >
            <img src='$dcfg->iconDir/$fileiconPrint' width='16' height='16' border='0' align='absmiddle'>&nbsp;$filenamePrint
               $layerIDTemp
              </td>
              <td $fBgColor style='width:$rcfg->webWidth' align='center'>$fLinkWebRun</td>
              <td $fBgColor style='width:$rcfg->viewWidth' align='center'>$fLinkView</td>
              <td $fBgColor style='width:$rcfg->renameWidth' align='center'>$fLinkRename</td>
              <td $fBgColor style='width:$rcfg->deleteWidth' align='center'>$fLinkDelete</td>
              <td $fBgColor style='width:$rcfg->sizeWidth' align='right'>$filesizePrint</td>
              <td $fBgColor style='width:$rcfg->tineWidth' align='center'>$filetimePrint</td>
              <td $fBgColor style='width:$rcfg->permsWidth'>$filepermsPrint</td>
              <td $fBgColor style='width:$rcfg->ownerWidth'>$fileownerPrint</td>
              <td width='*'>&nbsp;</td>
            </tr>";

        } // if End

   } // foreach End

    //  이미지 모드        &&    이미지 파일 (2군데있음)
    if ($rcfg->isImageMode && $isFileImageCheckLast ) {

            $colLoop = ($dcfg->rightImageCol - $imgCol);

            if ($colLoop != $dcfg->rightImageCol) {

                for ($colZ = 1; $colZ <= $colLoop; $colZ++) {

                    $tplList .= "<td width=$rcfg->imgThumbnailWidth bgcolor=$rcfg->winColor>&nbsp;</td>\n";
                } // for End
            }

                $tplList .= "</table>\n" .
                            "</td>\n" .
                            "</tr>\n";
    }

} // if End

$endTime = getMicroTime();
$totalTime = round($endTime - $startTime, 3);

include (HEADER_FILE);
?>
<script language="javascript">
<!--

	// left 프레임의 스크롤바 위치 top
	function getLeftScrollTop() {

		if (isExplorer) return parent.left.document.body.scrollTop;
		else            return parent.left.window.pageYOffset;
    }


    // 모든 프레임이 로딩되었다면 top 메뉴에 위치 표기
    // top 프레임이 right 프레임보다 늦게 불러질 경우 자바스크립트 에러
	//if (typeof (parent.top.dtop.topDirPos.innerHTML) != "undefined") {
   <?
   if ($rf != 1) {
   ?>
        // top 프레임에 현재 경로 위치 변경
        parent.dtop.topDirPos.innerHTML = "<?=$topDirPos?>";
   <? } ?>

    // 디렉토리, 파일 더블클릭시
    function rightDblClick(cdVal) {

        // 왼쪽 스크롤바 위치
        var leftScrollTop = getLeftScrollTop();

        window.parent.right.location.href = '<?="$dcfg->rightFile?cd="?>' + cdVal;

        // 왼쪽 프레임도
        window.parent.left.location.href = '<?="$dcfg->leftFile?cd="?>' + cdVal + '&toppos=' + leftScrollTop;
        return;
    }

    // 정렬
    function sortBy2(sortf, sortk) {

        var url = '<?=$dcfg->rightFile?>' + '?softf=' + sortf + '&sortk=' + sortk;
        location.replace(url);
    }


    // 선택된 디렉토리 배경색 변경
    function setBgcolor(number) {

        if (isExplorer) {

              // 이전 레이어 색을 바꾸고
              var mm = 'right' + document.layerCode.layer_id.value;
              document.all[mm].style.background= ''; //'#FFFFFF'; #FFFFFF => 배경이미지 사용시 안좋음
              
              // 선택된 레이어 색을 바꾸고
              var mm = 'right' + number;
              document.all[mm].style.background='<?=$dcfg->divBgcolor?>';
        }else{
              // 이전 레이어 색을 바꾸고
              var mm = 'right' + document.layerCode.layer_id.value;
              document.layers[mm].background= ''; //'#FFFFFF';
              
              // 선택된 레이어 색을 바꾸고
              var mm = 'right' + number;
              document.layers[mm].background='<?=$dcfg->divBgcolor?>';

        }

        // 선택된 레이어 같은 저장 
        document.layerCode.layer_id.value = number;
    }


    // 선택된 디렉토리 배경색 변경
    function setTrHidden(number) {

        if (isExplorer) {

            // 선택된 레이어 색을 바꾸고
            var mm = 'right' + number;
            //document.all[mm].style.background='<?=$dcfg->divBgcolor?>';
            hideLayer(mm);
        } else {
              
              // 선택된 레이어 색을 바꾸고
            var mm = 'right' + number;
            document.layers[mm].background='<?=$dcfg->divBgcolor?>';
            hideLayer(mm);
        }

        // 선택된 레이어 같은 저장 
        //document.layerCode.layer_id.value = number;
    }

    // 파일 삭제
    function fileDelete(file, filepath) {

        var msg = ":: '" + file + "'\n\n" +
                  "<?=$lg->fileDelQue?>"; // 이 파일을 삭제하시겠습니까?

        if ( confirm(msg)) {

            parent.top.process.location.href = '../php/file_manager.php?code=file_delete&file=' + file + '&filepath=' + filepath;
        } else {

            return;
        }
    }

    // 디렉토리 삭제
    function dirDelete(dir, dirpath) {

        var msg = ":: '" + dir + "'\n\n" +
                  "<?=$lg->dirDelQue?>";
                  //"이 디렉토리를 삭제하시겠습니까 ?\n\n" +
                 // "디렉토리가 비어 있어야만 삭제가 가능합니다.";

        if ( confirm(msg)) {

            parent.top.process.location.href = '../php/file_manager.php?code=dir_delete&dirpath=' + dirpath;
        } else {

            return;
        }
    }

    /**
    * 메세지 원도우를 띄운다
    *
    * @param  string  code : 코드
    * @param  integer winWidth  : 원도우 width
    * @param  integer winHegith : 원도우 height
    */
    function fileRenameWin(code, width, height, filename) {

        // 기본 크기 설정
        if (width == -1)  width  = 400;
        if (height == -1) height = 300;

        // center 위치 설정
        var left = sky.getCenterPosLeft(width);
        var top  = sky.getCenterPosTop(height);

        var option = 'width=' + width + ', height=' + height + ', left=' + left + ', top=' + top;
        winName = window.open('../php/file_manager_win.php?wmode=nwin&code=' + code + '&filename=' + filename, '' , option);
        winName.focus();

        return;

    } // fileRenameWin() End

    /**
    * 메세지 원도우를 띄운다
    *
    * @param  string  code : 코드
    * @param  integer winWidth  : 원도우 width
    * @param  integer winHegith : 원도우 height
    */
    function dirRenameWin(code, width, height, dirname) {

        // 기본 크기 설정
        if (width == -1)  width  = 400;
        if (height == -1) height = 300;

        // center 위치 설정
        var left = sky.getCenterPosLeft(width);
        var top  = sky.getCenterPosTop(height);

        var option = 'width=' + width + ', height=' + height + ', left=' + left + ', top=' + top;
        winName = window.open('../php/file_manager_win.php?wmode=nwin&code=' + code + '&dirname=' + dirname, '' , option);
        winName.focus();

        return;

    } // dirRenameWin() End

//-->
</script>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" scroll="no" OnResize="fixSize();setConfig();" <?=$dcfg->body?>>

<?
// <body 은 타이틀 td 크기 조정시 에러 방지 ondragstart="return false" onselectstart="return false"

  // 타이틀 바에 크기 조정을 위한 마크 위치 계산
  $tbarWidth = 7; // 크기의 1/2 => 이름 | 크기 의 | 중앙에 위치하게 됨
  
  // 테스트 시에 색을 지정해서 ...
  $tbarBg = '';

    $widthTemp   = $rcfg->nameWidth;
  
  // 이름 부분 위치
  $nameLayerPos  = $widthTemp - $tbarWidth;

    $widthTemp += $rcfg->webWidth  + 1;
    $widthTemp += $rcfg->viewWidth + 1;
    $widthTemp += $rcfg->renameWidth  + 1;
    $widthTemp += $rcfg->deleteWidth + 1;
    $widthTemp += $rcfg->sizeWidth + 1;

  $sizeLayerPos  = $widthTemp - $tbarWidth;

    $widthTemp += $rcfg->timeWidth + 1;
  $timeLayerPos  = $widthTemp - $tbarWidth;

    $widthTemp += $rcfg->permsWidth + 1;
  $permsLayerPos = $widthTemp - $tbarWidth;

    $widthTemp += $rcfg->ownerWidth + 1;
  $ownerLayerPos = $widthTemp - $tbarWidth;
   


// <td></td> <div></div> </td> ==> sort, 타이틀바 필드 조정 성공
?>
<table class="headerTable" cellspacing="1" cellpadding="0" id="messageHeader"  border=0 width="<?=$rcfg->titleWidth?>">
  <tr>
    <td id="nameHeader" style="width:<?=$rcfg->nameWidth?>;" onclick="sortBy('name','<?=$sortKeyUn?>');" title=""><?=$lg->rightTitleName?><?=$sortArName?></td>

    <div id='nameResL' style='position:absolute; left:<?=$nameLayerPos?>; background-color:<?=$tbarBg?>; width=15;cursor:e-resize;' onmouseover="isDrag=1;moveLayerID='name'">&nbsp;&nbsp;</div></td>

    <td id="webHeader"  width="<?=$rcfg->webWidth?>" align="center" style="cursor:default">w</td>
    <td id="viewHeader" width="<?=$rcfg->viewWidth?>" align="center" style="cursor:default">v</td>
    <td id="renameHeader"  width="<?=$rcfg->renameWidth?>" align="center" style="cursor:default">r</td>
    <td id="deleteHeader" width="<?=$rcfg->deleteWidth?>" align="center" style="cursor:default">d</td>
    <td id="sizeHeader" width="<?=$rcfg->sizeWidth?>" onclick="sortBy('size','<?=$sortKeyUn?>')" align="center" title="">
    <?=$lg->rightTitleSize?> <?=$sortArSize?></td>

    <div id='sizeResL' style='position:absolute; left:<?=$sizeLayerPos?>; background-color:<?=$tbarBg?>; width=15;cursor:e-resize;' onmouseover="isDrag=1;moveLayerID='size'">&nbsp;&nbsp;</div></td>

    <td id="timeHeader" width="<?=$rcfg->timeWidth?>" onclick="sortBy('time','<?=$sortKeyUn?>')" align="center" title=""><?=$lg->rightTitleDate?> <?=$sortArTime?></td>

    <div id='timeResL' style='position:absolute; left:<?=$timeLayerPos?>; background-color:<?=$tbarBg?>; width=15;cursor:e-resize;' onmouseover="isDrag=1;moveLayerID='time'">&nbsp;&nbsp;</div></td>
    

    <td id="permsHeader" width="<?=$rcfg->permsWidth?>" onclick="sortBy('perms','<?=$sortKeyUn?>')" align="center"  title=""><?=$lg->rightTitlePerms?> <?=$sortArPerms?></td>

    <div id='permsResL' style='position:absolute; left:<?=$permsLayerPos?>; background-color:<?=$tbarBg?>; width=15;cursor:e-resize;' onmouseover="isDrag=1;moveLayerID='perms'">&nbsp;&nbsp;</div></td>

    <td id="ownerHeader" width="<?=$rcfg->ownerWidth?>" onclick="sortBy('owner','<?=$sortKeyUn?>')" align="center"  title=""><?=$lg->rightTitleOwner?> <?=$sortArOwner?></td>

    <div id='ownerResL' style='position:absolute; left:<?=$ownerLayerPos?>; background-color:<?=$tbarBg?>; width=15;cursor:e-resize;' onmouseover="isDrag=1;moveLayerID='owner'">&nbsp;&nbsp;</div></td>

    <td width="*">&nbsp;</td>
  </tr>
</table>

<!--  스크롤 영역 (윗 부분은 스크롤 되지 않음) -->

<div id="scrollDiv">
<table border=0 cellpadding=0 cellspacing=0 height=100% style="background-image:url('<?=$rcfg->rightBgImage?>'); background-repeat:<?=$ucfg->rightBgImageRepeat?>;background-position:<?=$ucfg->rightBgImagePos?>;filter:alpha(opacity=<?=$ucfg->rightBgImageOpacity?>)">
<tr>
  <td valign=top>

<table border=0 cellpadding=0 cellspacing=1 width="<?=$rcfg->titleWidth?>"  class="headerTableBtm">
  <tr>
    <td id="nameHeaderSub" style="width:<?=$rcfg->nameWidth?>"></td>
    <td id="webHeaderSub" style="width:<?=$rcfg->webWidth?>"></td>
    <td id="viewHeaderSub" style="width:<?=$rcfg->viewWidth?>"></td>
    <td id="renameHeaderSub" style="width:<?=$rcfg->renameWidth?>"></td>
    <td id="deleteHeaderSub" style="width:<?=$rcfg->deleteWidth?>"></td>
    <td id="sizeHeaderSub" style="width:<?=$rcfg->sizeWidth?>"></td>
    <td id="timeHeaderSub" style="width:<?=$rcfg->timeWidth?>"></td>
    <td id="permsHeaderSub" style="width:<?=$rcfg->permsWidth?>"></td>
    <td id="ownerHeaderSub" style="width:<?=$rcfg->ownerWidth?>"></td>
    <td id="tempHeaderSub" width="*"></td>
  </tr>
<?=$tplList?>
</table>
    </td>
  </tr>
</table>
</div>
<!--  /스크롤 영역 (윗 부분은 스크롤 되지 않음) -->


<?
//$mesWidth = round( ($rcfg->nameWidth + $rcfg->webWidth + $rcfg->viewWidth) / 2);
$mesWidth = $rcfg->nameWidth + $rcfg->webWidth + $rcfg->viewWidth  + $rcfg->renameWidth + $rcfg->deleteWidth;
$dirFileTotal = $dirTotalReal + $fileTotal;
?>
<table class="headerTable" cellspacing="1" cellpadding="0" id="messageHeader2"  border=0 width="<?=$rcfg->titleWidth?>">
  <tr>
    <td id="nameHeader2" style="width:<?=$mesWidth?>" align="right"><?=$dirTotalReal?> Folders  / <?=$fileTotal?> Files / Total :  <?=$dirFileTotal?> </td>
    <td id="sizeHeader2" width="<?=$rcfg->sizeWidth?>" align="right"><?=$filesizeTotal?></td>
    <td width="*" nowrap>&nbsp;Time : <?=$totalTime?> Sec</td>
  </tr>
</table>

<script language="javascript">
<!--

window.onload = initMessageTreePrime;
window.onresize = fixSize;


//fixScrollDivSize();
//function fixScrollDivSize() {

//	document.styleSheets[0].addRule("#scrollDiv", "height: " + (sky.getClientHeight() - messageHeader.offsetHeight));
//}

// 하단 bae
function fixSize() {

    if (isExplorer) {
    	messageHeader.style.width  = Math.max(sky.getClientWidth(), 0);
	    messageHeader2.style.width = Math.max(sky.getClientWidth(), 0);
        scrollDiv.style.height     = Math.max(sky.getClientHeight() - messageHeader.offsetHeight - 20, 0);

    } else {

    	messageHeader.width  = Math.max(sky.getClientWidth(), 0);
	    messageHeader2.width = Math.max(sky.getClientWidth(), 0);
        scrollDiv.height     = Math.max(sky.getClientHeight() - messageHeader.offsetHeight - 200, 0);

    }
}

function initMessageTreePrime() {

	fixSize();
   
    // 이름, 크기, 수정한날짜 .. 이 부분을 같이 좌,우 스크롤 되게 해줌
    scrollDiv.onscroll = new Function("messageHeader.style.marginLeft = - scrollDiv.scrollLeft");
}
//-->
</script>

<div id="line" style="cursor:e-resize; position:absolute; visibility: hidden;background-color: #229332; left=100; top=0; width=1; height:100%">
</div>
<script language="javascript" src="<?=$_SKYDIR_URL?>common/js/sky_field_size.js"></script>

<div id='right0'></div>
<table border=0 cellpadding=1 cellspacing=0 width=100%>
<tr>
  <form name=layerCode method=post action=>
  <input type=hidden name=layer_id value=0>
  <input type=hidden name=cd value="<?=$cd?>">
  <td></td>
  </form>
</tr>
</table>

</body>
</html>


<script language="javascript">
<!--

    /**
    * type : 정렬필드
    * sortk : 값 asc, desc
    */
    function sortBy(type, sortKey, isSortRun) {


        var sortField = type;
        
        var url = '<?=$dcfg->rightFile?>' + '?cd=<?=$cd?>&sortField=' + sortField + '&sortKey=' + sortKey + '&sorton=1';
        location.replace(url);

        // 일단 지우고
		if (document.all.startArrow != null) {

			nameHeader._descending = true;
			startArrow.parentNode.removeChild(startArrow);
		}

		var el = document.getElementById(type + "Header");
//		sortTree(el, messageTree.childNodes[0], type);
	}


    function sortTree(srcEl, treeNode, type, bDesc) {

    	var el = srcEl;
	
    	if (el == null)
	    	return;

    	if (bDesc != null)
    		el._descending = bDesc;
    	else
	    	if (el._descending)	// catch the null
    			el._descending = false;
    		else
	    		el._descending = true;
		
    	if (treeNode.arrow != null) {

	    	if (treeNode.arrow.parentNode != el) {
    			treeNode.arrow.parentNode._descending = null;	//reset sort order		
    		}

	    	treeNode.arrow.parentNode.removeChild(treeNode.arrow);
    	}
	
    	if (el._descending)
	    	treeNode.arrow = arrowDown.cloneNode(true);
    	else
    		treeNode.arrow = arrowUp.cloneNode(true);
		
	    el.appendChild(treeNode.arrow);
    }


    // asc, desc 마크를 표기하기 위한 것
    var arrowUp, arrowDown;

//function initSortTree() {

    // Note that the class arrow should be defined in the css
	arrowUp = document.createElement("SPAN");
	var tn = document.createTextNode("6");
	arrowUp.appendChild(tn);
	arrowUp.className = "sortArrow";

	arrowDown = document.createElement("SPAN");
	var tn = document.createTextNode("5");
	arrowDown.appendChild(tn);
	arrowDown.className = "sortArrow";
//}

    function editOpen() {

//         window.location.href = 'file:///' + '<?=$dcfg->editPath?>';
    }

//-->
</script>


<script language="javascript" src="<?=$_SKYDIR_URL?>common/js/sky_imgsize.js"></script>

<script language="javascript">
<!--
    
     // 좌측 하단 이미지 미리보기 부분
     
    imgViewWidth = 0
    imgViewHeight = 0;
    imgViewSrc = '';


    // 왼쪽하단 이미지 미리보기
    function imgPreview(imgNameX, imgNameOri) {   

       // 현재 프레임의 크기를 구한다
       leftWidth  =  getClientWidthLeftBottom();
       leftHeight =  getClientWidthLeftBottom();

        // width, height 기준으로만 정렬한다
        widthMax  = leftWidth - 20;
        heightMax = leftHeight - 60;

        tempImg = new Image();
        tempImg.src = imgNameX;

        // 창크기에 맞는 이미지 크기 구함
        getImageSize(tempImg.width,tempImg.height);

        // 실제 크기로 보기를 위한 크기 설정
        imgViewWidth   = tempImg.width;
        imgViewHeight  = tempImg.height;
        imgViewSrc = imgNameX;

	   if (newImageWidth == 0 || newImageHeight == 0 ){

	       newImageWidth = 100;
      	   newImageHeight = 100;
	    }

        // 이미지 값 전달
        parent.left_bottom.preview.src = imgNameX;
        parent.left_bottom.preview.width = newImageWidth;
        parent.left_bottom.preview.height = newImageHeight;

        // 이미지 크기 정보 전달 000x000
        parent.left_bottom.previewInfoSize.innerHTML = "&nbsp;&nbsp; " + imgViewWidth + ' x ' + imgViewHeight;

        // 이미지 정보 전달 이름
        parent.left_bottom.previewInfoName.innerHTML = "&nbsp;&nbsp; " + imgNameOri;

    } // imgPreview() End


    var myimages = new Array();
    
    // 이미지 미리 불어오기
    function preloadImages() { 

        for (i=0; i < preloadImages.arguments.length; i++) {  

            myimages[i] = new Image();
            myimages[i].src=preloadImages.arguments[i] 
        } 
    } 
    
<?  // 이미지가 있으면
    if (count($fileImageReload) > 0) {
        
        $z = 1;
        foreach($fileImageReload as $qKey => $qVal) {

            if ($z > $rcfg->imgReloadMax) break;

            // 이미지경로 누적
            $imgList .= "'" . $qVal . "', ";

            $z++;
        } // foreach End

    } // if End

        $imgList .= "''";       

?>
    // 자바스크립트로 출력
    preloadImages(<?=$imgList?>);

   // 웹아이콘 클릭시 -> 웹에서 실행할 수 있는 경로가 아니라는 메세지
    function errMsgNotWeb() {

        //alert('* Error !');
    }


    // 이미지 실제 크기로 보기    
    function imgViewWin() {

        var width;
        var height;
        var scrollbars = 'no';

        width = imgViewWidth;
        height = imgViewHeight;

        if ( width > (screen.width - 20))  {
            
            width  = screen.width  - 40;
            scrollbars = 'yes';
        }

        if ( height > (screen.height - 20)) { 
            
            height = screen.height - 80;
            scrollbars = 'yes';
        }

        var option = 'left=10, top=10, width=' + width + ', height=' + height + ', scrollbars=' + scrollbars + ', resizable=yes';
    	var url = '../php/imgview.php?file=' + imgViewSrc;

    	window.open( url, '', option );

    }


   // 왼쪽 하단 이미지 미리보기 부분 초기화
    function setLeftBottomImgHide() {

        // 오른쪽 이미지 숨김
        parent.left_bottom.preview.src = '<?=$dcfg->spaceImg?>';

        // 이미지 크기 정보 전달 000x000
        top.left_bottom.previewInfoSize.innerHTML = "&nbsp;&nbsp; ";

        // 이미지 크기 정보 전달 이름
        top.left_bottom.previewInfoName.innerHTML = "&nbsp;&nbsp; ";
    }

   // 왼쪽 하단 이미지 미리보기 부분 초기화
   <?
   if ($rf != 1) {
   ?>
    setLeftBottomImgHide();

   <? } ?>

<?
    if ($isWebRun) {
?>
       // parent.left_bottom.leftBottomMsg.style.visibility = 'hidden';

<? } else { ?>

//        parent.left_bottom.leftBottomMsg.style.visibility = 'visible';

<? } ?>

//-->
</script>