<?php
/**
* 파일/디렉토리 작업처리
*
* @filename : php/file_manager.php
* @version  : v 1.0 2003.04.29 18:17
* @author   : nsl <smpoem@magicn.com>
*/

include '../common/skydir_init.php';

// ftp class 초기화
$ftp = new SkyFtp($rcfg->ftpHost, $rcfg->ftpPort, $rcfg->ftpUserID, $rcfg->ftpUserPW);

// ftp 연결
$ftp->ftpLogin();

switch($code) {

    // 파일삭제
    case 'file_delete'  : setFileDelete(); break;

    // 파일이름 변경
    case 'file_rename'  : setFileRename(); break;

    // 디렉토리 삭제
    case 'dir_delete'   : setDirDelete(); break;

    // 디렉토리 이름 변경
    case 'dir_rename'  : setDirRename(); break;
    //  
    default :

} // switch End

// ftp close
$ftp->ftpClose();

exit();


// 파일 삭제
function setFileDelete() {

    global $ftp;
    global $rcfg;
    global $lg;

    @extract($_REQUEST, EXTR_SKIP);

    if (!$ftp->ftp_delete(getInitDirRight() . $filepath)) {

       // 이 파일을 삭제할 수 없습니다!
       jsAlertErrorMsg(":: '$file'\\n\\n$lg->fileDelError");
    } else {

        fileJsPrint('parent.right.location.reload()');
    }
} 

// 디렉토리 삭제
function setDirDelete() {

    global $ftp;
    global $rcfg;
    global $lg;

    @extract($_REQUEST, EXTR_SKIP);

    //                       초기디렉토리    . 현재 디렉토리
    if (!$ftp->ftp_rmdir(getInitDirRight() . $dirpath)) {

       // 이 디렉토리를 삭제할 수 없습니다!
       jsAlertErrorMsg(":: '$dirpath'\\n\\n$lg->dirDelError");
    } else {

        fileJsPrint('parent.right.location.reload()');
        fileJsPrint('parent.left.location.reload()');
    }
} 

// 파일이름 변경
function setFileRename() {

    global $ftp;
    global $rcfg;
    global $lg;

    @extract($_REQUEST, EXTR_SKIP);

    // 
    $filename    = getInitDirRight() . $cd . '/' . $filename;
    $newFilename = getInitDirRight() . $cd . '/' . $newFilename;

    if ( !$ftp->ftp_rename($filename, $newFilename) ) {

       // 이 파일 이름을 변경할 수 없습니다!
       jsAlertErrorMsg(":: '$filename'\\n\\n$lg->fileRenameError");
    } else {

        fileJsPrint("parent.opener.top.right.location.reload();\nwindow.close();\n");
    }


}


// 디렉토리 이름 변경
function setDirRename() {

    global $ftp;
    global $rcfg;
    global $lg;

    @extract($_REQUEST, EXTR_SKIP);

    // 
    $dirname    = getInitDirRight() . $cd . '/' . $dirname;
    $newDirname = getInitDirRight() . $cd . '/' . $newDirname;

    // 디렉토리 명에 공백이 있다면
    if ( ereg("[[:space:]]", $newDirname) ) {

       // 디렉토리명에 공백이 있으면 안됩니다!
       jsAlertErrorMsg(":: '$newDirname'\\n\\n$lg->dirSpaceError");
    }

    // 새로운 디렉토리로 이동해 본다.
    $rs = @ftp_chdir($ftp->ftpCon, $newDirname);

    // 디렉토리가 존재한다면
    if ($rs) {
     
        // 원래 디렉토리로 되돌아옴
        $rs = @ftp_chdir($ftp->ftpCon, $dirname);

       // 이 디렉토리가 이미 존재합니다!
       jsAlertErrorMsg(":: '$newDirname'\\n\\n$lg->dirRenameExistError");
    } else {


        if ( !$ftp->ftp_rename($dirname, $newDirname) ) {

           // 이 디렉토리 이름을 변경할 수 없습니다!
           jsAlertErrorMsg(":: '$dirname'\\n\\n$lg->dirRenameError");
        } else {

            fileJsPrint("parent.opener.top.left.location.reload();\n" . 
                        "parent.opener.top.right.location.reload();\nwindow.close();\n");

        }
    }
}
?>
