<?php
/**
* 디렉토리 만들기, 파일 올리기 처리
*
* @filename : php/file_win_process.php
* @version  : v 1.0 2003.04.22 14:21:33
* @author   : nsl <smpoem@magicn.com>
*/

// 파일 전송을 위해서 실행시간 조정
set_time_limit(0);

include '../common/skydir_init.php';

// ftp class 초기화
$ftp = new SkyFtp($rcfg->ftpHost, $rcfg->ftpPort, $rcfg->ftpUserID, $rcfg->ftpUserPW);

// ftp 연결
$ftp->ftpLogin();

switch($code) {

    // 디렉토리 만들기
    case 'file_dir'  : setFileDir(); break;

    // 파일 업로드
    case 'file_fileup'  : setFileFilePut(); break;

    default :

} // switch End

// ftp close
$ftp->ftpClose();

exit();


// 파일 전송 
function setFileFilePut() {

    global $dcfg;
    global $rcfg;
    global $ucfg;
    global $lg; // 언어
    global $ftp;

    include '../class/sky_fileup_class.php';

    @extract($_POST, EXTR_SKIP);

    // 파일명 중복시 덮어 씌울지 유무
    $ucfg->isFileOverwrite = $isFileOverwrite;

    // 전송유형 
    $ucfg->fileTransferType = $fileTransferType;

    // 환경설정 저장
    setConfigFile($dcfg->uconfigFile, $ucfg);

    //                            초기디렉토리    . 현재 디렉토리
    $ftp->ftp_chdir(urldecode(getInitDirRight() . $cd));

    // 파일 업로드 객체
    $upfile = new SkyFileUp();

    
    for ($z = 0; $z <= $dcfg->fileUpNumber; $z++) {

        if ( $upfile->getUploadFileArray ('ufile', $z ) ) {

            // 파일명과 확장자 분리
            $upfile->getFileExt();
            
            if ($fileTransferType == 'ascii') {

                $transferType = FTP_ASCII; 
                //  $transferType = 'FTP_ASCII'; 이렇게 하면 틀림 FTP_ASCII -> 상수임


            } else if ($fileTransferType == 'binary') {

                $transferType = FTP_BINARY;
            } else {           
                
                if( in_array(strtolower($upfile->fileExt) , $rcfg->textViewExt)) {

                    $transferType = FTP_ASCII;
                } else {

                    $transferType = FTP_BINARY;
                }
            }

            //-2(올릴파일이 존재하지 않음), -3(FTP 전송 실패), -4(파일이 존재함),  1(성공)
            $result =  $ftp->ftp_put($upfile->getFileNameTmp(), $upfile->getFileName(), $isFileOverwrite, $transferType);
           
            if ($result == 1) {
               //                               성공
               $resultMsg[] = "<font color=blue>$lg->fileUpSuccessful : </font>" . $upfile->getFileName();
            } else if ($result == -2) {
               //                              실패                                                                파일에러!
               $resultMsg[] = "<font color=red>$lg->fileUpFail : </font>" . $upfile->getFileName() . " <font color=red>($lg->fileUpFileError !)</font>";
            } else if ($result == -3) {
               //                              실패                                                                       실패
               $resultMsg[] = "<font color=red>$lg->fileUpFail : </font>" .$upfile->getFileName() . " <font color=red>($lg->fileUpFail !)</font>";
            } else if ($result == -4) {
               //                              실패                                                        파일이 이미 존재함
               $resultMsg[] = "<font color=red>$lg->fileUpFail : </font>" .$upfile->getFileName() . " <font color=red>($lg->fileUpExist !)</font>";
            }
        }
    }

    // 전송결과 메세지
    include 'file_fileup_msg.php';
} // 

// 디렉토리 만들기
function setFileDir() {

    global $dcfg;
    global $rcfg;
    global $lg; // 언어
    global $ftp;

    @extract($_POST, EXTR_SKIP);

    //                           초기디렉토리     . 현재 디렉토리
    $ftp->ftp_chdir(urldecode(getInitDirRight() . $cd));

    for ($z = 0; $z <= $dcfg->fileUpNumber; $z++) {

        $dirName = $_POST['ufile'][$z];


        // 값이 있으면
        if (!empty($dirName)) {

                // 디렉토리 명에 공백이 있다면 -> 만들지 않음
                if ( ereg("[[:space:]]", $dirName) ) {

                    $result = 0;
                } else {

                    $result =  $ftp->ftp_mkdir($dirName);
                }



            if ($result) {
                //                                   성공
                $resultMsg[] = "<font color=blue>$lg->fileUpSuccessful : </font> " . $dirName;
            } else {

                //                              실패
                $resultMsg[] = "<font color=red>$lg->fileUpFail : </font>" . $dirName;
            }
        }
        
    } // for End


    // 전송결과 메세지
    include 'file_fileup_msg.php';
} // if End

?>
